local worm = {len    = 30,
              speedx = 164,
              speedy = 100,
              img    = love.graphics.newImage("ball.png"),
              img2   = love.graphics.newImage("ball_eye.png"),
              x      = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
              y      = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
              old_x  = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
              old_y  = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
              angle  = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
              xvel   = {},
              yvel   = {},
              dirx   = 1,
              diry   = 1,
              timer  = 3, 
              }
worm.angle[1] = 32.373
love.window.setMode(854, 480)
local debug_text_y = love.graphics.getHeight()/2-love.graphics.getFont():getHeight("J")*3
love.mouse.setVisible(false)

function love.update(dt)
   worm.timer = worm.timer + dt
   if worm.timer > 1 then
      x, y = love.mouse.getPosition()
      worm.timer = 0
   end

      worm.dx, worm.dy = x - worm.x[1], y - worm.y[1]
      worm.hx, worm.hy = -math.sin(worm.angle[1]), math.cos(worm.angle[1])
      worm.dotp2 = worm.dx*worm.hx + worm.dy*worm.hy
      worm.step = 10*dt
      if worm.dotp2 < 0 then
         worm.step = -worm.step
      end

      worm.current_speed_x = (worm.current_speed_x or 0) + 164 *dt
      if worm.current_speed_x > worm.speedx then
         worm.current_speed_x = worm.speedx
      end
      

      worm.current_speed_y = (worm.current_speed_y or 0) + 164 *dt
      if worm.current_speed_y > worm.speedy then
         worm.current_speed_y = worm.speedy
      end

	-- turn
	worm.angle[1] = worm.angle[1] + worm.step

	-- move forward
	worm.x[1] = worm.x[1] + (math.cos(worm.angle[1])*worm.current_speed_x*dt)
	worm.y[1] = worm.y[1] + (math.sin(worm.angle[1])*worm.current_speed_y*dt)

   
   --worm.old_x[1] = worm.x[1] + 0 
   --worm.old_y[1] = worm.y[1] + 0

   
   --worm.x[1] = worm.x[1] + worm.current_speed_x * dt * worm.dirx
   --worm.y[1] = worm.y[1] + worm.current_speed_y * dt * worm.diry

   --worm.xvel[1] = worm.x[1] - worm.old_x[1] -- прилежащий катет
   --worm.yvel[1] = worm.y[1] - worm.old_y[1] -- противолежащий катет

   

   --local pi = math.pi
   --local tangens  = worm.yvel[1]/worm.xvel[1]
   --local radians = math.atan2(worm.yvel[1],worm.xvel[1])
   --local degrees = radians * 180/pi
   
   --worm.angle[1] = radians
   
   worm.dt = dt
   

--   if  worm.x[1] > love.graphics.getWidth()/2+40  then worm.dirx = -1 worm.current_speed_x = 0 end
--   if  worm.x[1] < -40                            then worm.dirx =  1 worm.current_speed_x = 0 end

--   if  worm.y[1] > love.graphics.getHeight()/2+40 then worm.diry = -1 worm.current_speed_y = 0 end
--   if  worm.y[1] < -40                            then worm.diry =  1 worm.current_speed_y = 0 end

   for i=2, worm.len do
       if math.abs(worm.x[i-1]-worm.x[i]) + math.abs(worm.y[i-1]-worm.y[i]) > 10 then

          worm.x[i] = worm.x[i] * 0.79 + worm.x[i-1] * 0.21
          worm.y[i] = worm.y[i] * 0.79 + worm.y[i-1] * 0.21

          worm.xvel[i] = worm.x[i]-worm.x[i-1]
          worm.yvel[i] = worm.y[i]-worm.y[i-1]

          local tangens  = worm.yvel[i]/worm.xvel[i]
          local radians = math.atan(tangens)          
          if worm.xvel[i]>0 then
             radians = radians + math.pi
          end
          worm.angle[i] = radians
       end
   end
end


function love.draw()
--   love.graphics.scale(2)
   for i=worm.len, 1, -1 do
       love.graphics.setColor(220, 100, 50)
       if i == 1 then
          love.graphics.setColor(255, 50, 50)
       end     
       love.graphics.draw(worm.img,  worm.x[i], worm.y[i], worm.angle[i], 1, 1, worm.img:getWidth()/2, worm.img:getWidth()/2)
       love.graphics.setColor(200,255,255)
       love.graphics.draw(worm.img2, worm.x[i], worm.y[i], worm.angle[i], 1, 1, worm.img:getWidth()/2, worm.img:getWidth()/2)
       love.graphics.print("Angle: " .. math.floor(worm.angle[i]*180/math.pi), 0,  i * 15)
   end
   love.graphics.setColor(255, 255, 255)
   local xx, yy = love.mouse.getPosition()
   love.graphics.rectangle("line", x-5, y-5, 10, 10)
   love.graphics.setColor(255, 205, 205)
   love.graphics.rectangle("line", xx-5, yy-5, 10, 10)
   
end
